/* ---------------------------------------------------------------- */
/* LICENSED MATERIALS PROPERTY OF IBM                               */
/*                                                                  */
/* (C)Copyright IBM Corp.  2003                                     */
/*                                                                  */
/* All rights reserved                                              */
/*                                                                  */
/* US Government Users Restricted Rights -                          */
/* Use, duplication or disclosure restricted by                     */
/* GSA ADP Schedule Contract with IBM Corp.                         */
/*  --------------------------------------------------------------- */
/*                                                                  */
//////////////////////////////////////////////////////////////////////
//
//                          DISCLAIMER
//                          ----------
//
//This material contains IBM copyrighted sample programming source code.
//IBM grants you a nonexclusive copyright license to use the Sample
//Code as an example from which you can generate similar function
//tailored to your own specific needs.  Your license to this Sample
//Code provides you no right or licenses to any IBM patents.
//
//The Sample Code is provided by IBM for illustrative purposes only.
//The Sample Code has not been thoroughly tested under all conditions.
//IBM, therefore, cannot guarantee or imply its reliability, serviceability,
//performance or function.  All Sample Code contained herein
//is provided to you "AS IS".  THE IMPLIED WARRANTIES OF
//MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE 
//AND NON-INFRINGEMENT ARE EXPRESSLY DISCLAIMED.
//SOME JURISDICTIONS DO NOT ALLOW THE EXCLUSION 
//OF IMPLIED WARRANTIES, SO THE ABOVE EXCLUSIONS 
//MAY NOT APPLY TO YOU. IN NO EVENT WILL IBM BE LIABLE 
//TO ANY PARTY FOR ANY DIRECT, INDIRECT, SPECIAL OR 
//OTHER CONSEQUENTIAL DAMAGES FOR ANY USE OF 
//THE SAMPLE CODE INCLUDING, WITHOUT LIMITATION, 
//ANY LOST PROFITS, BUSINESS INTERRUPTION, LOSS OF 
//PROGRAMS OR OTHER DATA ON YOUR INFORMATION 
//HANDLING SYSTEM OR OTHERWISE, EVEN IF WE ARE 
//EXPRESSLY ADVISED OF THE POSSIBILITY OF SUCH 
//DAMAGES. 
//
//////////////////////////////////////////////////////////////////////

import java.util.Iterator;

import com.ibm.able.Able;
import com.ibm.able.AbleException;
import com.ibm.able.rules.AbleRuleSet;

public class AppRuleSet
{
   	
  	                                       
    public static void main(String[] args)
    {
        try {
            // ruleset to be read - requires able.home property to be set
            String rules = "C:\\Able-Class\\source\\answers\\VehicleForward2.arl";

            // Can pass name of ARL file to ruleset
            if (args != null && args.length > 0) rules = args[0];
            
            // must know the structure of that agent's inputbuffer to use it this way
            // note agents can have a double[] buffer if all its values are numeric
            String[][] data  = new String[][]{
            	{"small", "2", "0", "yes"}, };

            // restore the agent 
            AbleRuleSet ruleSet = new AbleRuleSet();
            ruleSet.parseFromARL(rules);
            ruleSet.init();
        
            // prove we're not cheating by showing the current values
            Able.startTraceLogging(Able.TRC_LOW,Able.TRC_NONE,null);
  	 	
            Able.TraceLog.text(Able.TRC_LOW,"Input  current: " + displayBuffer((Object[])ruleSet.getInputBuffer()));
            Able.TraceLog.text(Able.TRC_LOW,"Output current: " + displayBuffer((Object[])ruleSet.getOutputBuffer()));
        
            // pass the agent data and get the result
            Object[]output = (Object[]) ruleSet.process(data[0]);
        
            // show the input that was passed and the result obtained
            Able.TraceLog.text(Able.TRC_LOW,"Input  result: " + displayBuffer(data[0]));
            Able.TraceLog.text(Able.TRC_LOW,"Output result: " + displayBuffer(output));     

        } catch (AbleException exp) {
   	 	if (exp.getExceptions() == null) {
   	 			System.out.println(exp);
   	 	} else {
   	 		Iterator it = exp.getExceptions().iterator();
   	 		while (it.hasNext()) {
   	 			Exception e = (Exception)it.next();
   	 			System.out.println(e);
   	 			e.printStackTrace();
   	 		}
   	 	}
   	 } catch (Exception exp) {
   	 	System.out.println(exp.getLocalizedMessage());
   	 	exp.printStackTrace();
   	 }
     System.exit(0);
  }

  private static String displayBuffer(Object[] buf) {
      StringBuffer buffer = new StringBuffer("");
      if (buf == null) {
      	buffer.append(buf);
      } else {
        for (int i = 0; i < buf.length; i++) buffer.append(buf[i] + " ");
      }
      return buffer.toString();
   }
   
   private static String displayBuffer(double[] buf) {
      StringBuffer buffer = new StringBuffer("");
      if (buf == null) {
      	buffer.append(buf);
      } else {
        for (int i = 0; i < buf.length; i++) buffer.append(buf[i] + " ");
      }
      return buffer.toString();
   }

}
