/* ---------------------------------------------------------------- */
/* LICENSED MATERIALS PROPERTY OF IBM                               */
/*                                                                  */
/* (C)Copyright IBM Corp.  2003                                     */
/*                                                                  */
/* All rights reserved                                              */
/*                                                                  */
/* US Government Users Restricted Rights -                          */
/* Use, duplication or disclosure restricted by                     */
/* GSA ADP Schedule Contract with IBM Corp.                         */
/*  --------------------------------------------------------------- */
/*                                                                  */
//////////////////////////////////////////////////////////////////////
//
//                          DISCLAIMER
//                          ----------
//
//This material contains IBM copyrighted sample programming source code.
//IBM grants you a nonexclusive copyright license to use the Sample
//Code as an example from which you can generate similar function
//tailored to your own specific needs.  Your license to this Sample
//Code provides you no right or licenses to any IBM patents.
//
//The Sample Code is provided by IBM for illustrative purposes only.
//The Sample Code has not been thoroughly tested under all conditions.
//IBM, therefore, cannot guarantee or imply its reliability, serviceability,
//performance or function.  All Sample Code contained herein
//is provided to you "AS IS".  THE IMPLIED WARRANTIES OF
//MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE 
//AND NON-INFRINGEMENT ARE EXPRESSLY DISCLAIMED.
//SOME JURISDICTIONS DO NOT ALLOW THE EXCLUSION 
//OF IMPLIED WARRANTIES, SO THE ABOVE EXCLUSIONS 
//MAY NOT APPLY TO YOU. IN NO EVENT WILL IBM BE LIABLE 
//TO ANY PARTY FOR ANY DIRECT, INDIRECT, SPECIAL OR 
//OTHER CONSEQUENTIAL DAMAGES FOR ANY USE OF 
//THE SAMPLE CODE INCLUDING, WITHOUT LIMITATION, 
//ANY LOST PROFITS, BUSINESS INTERRUPTION, LOSS OF 
//PROGRAMS OR OTHER DATA ON YOUR INFORMATION 
//HANDLING SYSTEM OR OTHERWISE, EVEN IF WE ARE 
//EXPRESSLY ADVISED OF THE POSSIBILITY OF SUCH 
//DAMAGES. 
//
//////////////////////////////////////////////////////////////////////

package com.ibm.able.examples;

//====================================================================
// Imports
//====================================================================
import java.io.IOException;

import com.ibm.able.Able;
import com.ibm.able.AbleObject;
import com.ibm.able.agents.AbleNeuralPredictionAgent;

/**
 * This class demonstrates how to use an agent created in the Agent Editor
 * in a Java application.  In this case a Neural Prediction agent is 
 * created in the agent editor, trained, and saved, and then this app
 * uses the saved agent to predict storage utilization.
 */
public class PredictionApp
{

    //-----------------------------------------------------------------
    // Constructors
    //-----------------------------------------------------------------
    private PredictionApp()
    {
    }

    //-----------------------------------------------------------------
    // Main method
    //-----------------------------------------------------------------
    public static void main(String[] args)
    {
        Able.startMessageAndTraceLogging();
        PredictionApp test = new PredictionApp();
        // messages are generally retrieved from message bundle
        // use error level just to avoid displaying extra messages
        Able.MessageLog.text(Able.MSG_ERROR, "Starting test");
        test.test();
    }

    //-----------------------------------------------------------------
    // Methods
    //-----------------------------------------------------------------
    private void test()
    {

        AbleNeuralPredictionAgent predictAgent = null;

        try
        {

            //-----------------------------------------------------------------
            // Add code here to restore the serialized prediction agent 
            // that you created in an earlier lab.  Use the static method
            // AbleObject.restoreFromSerializedFile()
            //-----------------------------------------------------------------

            //-----------------------------------------------------------------
            // This data gets passed to the prediction agent
            //If you really wanted to use the storage prediction agent, this is the place
            //where you would set the inputs with current information from the system.
            //In this case, everytime it runs it uses these inputs   
            //-----------------------------------------------------------------
            double Lib1NumberOfFiles = 152;
            double Lib1Size = 3452;
            double Lib2NumberOfFiles = 284;
            double Lib2Size = 4444;
            double Lib3NumberOfFiles = 226;
            double Lib3Size = 3667;
            double Lib4NumberOfFiles = 95;
            double Lib4Size = 477;
            double Lib5NumberOfFiles = 656;
            double Lib5Size = 54978;
            double Lib6NumberOfFiles = 45;
            double Lib6Size = 5521;
            double Lib7NumberOfFiles = 13;
            double Lib7Size = 999;
            double StorageUtilization = 0;

            //-----------------------------------------------------------------
            // Put the data into a double [] -- this is what gets passed into
            // the agent's input buffer.
            //-----------------------------------------------------------------
            double inputdoubleBuf[] = {
                    Lib1NumberOfFiles,
                    Lib1Size,
                    Lib2NumberOfFiles,
                    Lib2Size,
                    Lib3NumberOfFiles,
                    Lib3Size,
                    Lib4NumberOfFiles,
                    Lib4Size,
                    Lib5NumberOfFiles,
                    Lib5Size,
                    Lib6NumberOfFiles,
                    Lib6Size,
                    Lib7NumberOfFiles,
                    Lib7Size,
                    StorageUtilization };

            //-----------------------------------------------------------------
            // Add code here to call setInputBuffer() on the agent to pass it data.
            //-----------------------------------------------------------------

            //-----------------------------------------------------------------
            // Add code here to call agent's process method to process input buffer
            //-----------------------------------------------------------------

            //-----------------------------------------------------------------
            // Add code here to get the output data from the agent.  It returns a double[].
            //-----------------------------------------------------------------

            //-----------------------------------------------------------------
            // Add code here to display the predicted storage usage.
            //-----------------------------------------------------------------

        } catch (ClassNotFoundException e)
        {
            Able.MessageLog.text(Able.MSG_ERROR, "Error: " + e);
        } catch (IOException e)
        {
            Able.MessageLog.text(Able.MSG_ERROR, "Error: " + e);
        }
        Able.MessageLog.text(Able.MSG_ERROR, "Done!");
    }
}
