/* ---------------------------------------------------------------- */
/* LICENSED MATERIALS PROPERTY OF IBM                               */
/*                                                                  */
/* Product(s):                                                      */
/*     5722-SS1                                                     */
/*                                                                  */
/* (C)Copyright IBM Corp.  2003                                     */
/*                                                                  */
/* All rights reserved                                              */
/*                                                                  */
/* US Government Users Restricted Rights -                          */
/* Use, duplication or disclosure restricted by                     */
/* GSA ADP Schedule Contract with IBM Corp.                         */
/*  --------------------------------------------------------------- */
/*                                                                  */
//////////////////////////////////////////////////////////////////////
//
//                          DISCLAIMER
//                          ----------
//
//This material contains IBM copyrighted sample programming source code.
//IBM grants you a nonexclusive copyright license to use the Sample
//Code as an example from which you can generate similar function
//tailored to your own specific needs.  Your license to this Sample
//Code provides you no right or licenses to any IBM patents.
//
//The Sample Code is provided by IBM for illustrative purposes only.
//The Sample Code has not been thoroughly tested under all conditions.
//IBM, therefore, cannot guarantee or imply its reliability, serviceability,
//performance or function.  All Sample Code contained herein
//is provided to you "AS IS".  THE IMPLIED WARRANTIES OF
//MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE 
//AND NON-INFRINGEMENT ARE EXPRESSLY DISCLAIMED.
//SOME JURISDICTIONS DO NOT ALLOW THE EXCLUSION 
//OF IMPLIED WARRANTIES, SO THE ABOVE EXCLUSIONS 
//MAY NOT APPLY TO YOU. IN NO EVENT WILL IBM BE LIABLE 
//TO ANY PARTY FOR ANY DIRECT, INDIRECT, SPECIAL OR 
//OTHER CONSEQUENTIAL DAMAGES FOR ANY USE OF 
//THE SAMPLE CODE INCLUDING, WITHOUT LIMITATION, 
//ANY LOST PROFITS, BUSINESS INTERRUPTION, LOSS OF 
//PROGRAMS OR OTHER DATA ON YOUR INFORMATION 
//HANDLING SYSTEM OR OTHERWISE, EVEN IF WE ARE 
//EXPRESSLY ADVISED OF THE POSSIBILITY OF SUCH 
//DAMAGES. 
//
//////////////////////////////////////////////////////////////////////
package com.ibm.able.platform.examples;

import java.io.Serializable;

import com.ibm.ui.framework.DataBean;

import com.ibm.ui.framework.IllegalUserDataException;
import com.ibm.ui.framework.Capabilities;
/**
 * @author jtawe
 *
 * To change this generated comment edit the template variable "typecomment":
 * Window>Preferences>Java>Templates.
 * To enable and disable the creation of type comments go to
 * Window>Preferences>Java>Code Generation.
 */
public class EServerTemplateAgentAboutDataBean implements DataBean, Serializable
{
	// Contains the value for AboutMessage
	private String m_sAboutMessage;

	/**
	 * This method is called by the framework to store the value for AboutMessage
	 * @param s The string control's current value.
	 * @exception IllegalUserDataException Should be thrown when user entered data is invalid.
	 * @see com.ibm.ui.framework.DataBean
	 */
	public void setAboutMessage(String s) throws IllegalUserDataException {
		m_sAboutMessage = s;
	}

	/**
	 * This method returns the value for AboutMessage
	 * @return The value for the string control.
	 * @see com.ibm.ui.framework.DataBean
	 */
	public String getAboutMessage() {
		return m_sAboutMessage;
	}

	/**
	 * Returns a <code>Capabilities</code> object which identifies
	 * the attributes that aren't supported by this <code>DataBean</code>.
	 * <p>
	 * There are many reasons why a <code>DataBean</code> might not support 
	 * a given attribute.  For example:
	 * <p>
	 * <ul>
	 * <li>The attribute may not be supported by the server platform.
	 * <li>The attribute may not be supported by the operating system version 
	 * that is running on the server.
	 * <li>The attribute may be supported, but the current user of
	 * the client application may not be authorized to change the attribute.
	 * </ul>
	 * <p>
	 * The <code>Capabilities</code> object may provide a list
	 * of instructions, or <code>EventTask</code>s, which the
	 * UI framework is to perform.  Typically these involve disabling
	 * or removing certain UI components from a panel.
	 * <p>
	 * @return  A <code>Capabilities</code> object which reflects this object's capabilities.
	 * @see com.ibm.ui.framework.DataBean
	 */
	public Capabilities getCapabilities() {
		return null;
	}

	/**
	 * Validates any changes that have been applied to this object via
	 * its accessor methods.
	 * <p>
	 * This method is called just prior to <code>save</code> to give
	 * the receiver an opportunity to verify that its data is consistent
	 * with any changes made to other <code>DataBean</code>s associated
	 * with a given task.  If an inconsistency is discovered the
	 * <code>DataBean</code> should throw an <code>IllegalUserDataException</code>.
	 * This will prevent the changes from being committed.
	 * <p>
	 * @exception IllegalUserDataException Should be thrown when user entered data is invalid.
	 * @see com.ibm.ui.framework.DataBean
	 */
	public void verifyChanges() throws IllegalUserDataException {
	}

	/**
	 * Initializes this object.
	 * <p>
	 * This method should be called before passing the <code>DataBean</code>
	 * to <code>UserTaskManager</code>.  On return from this method the bean
	 * should be in a state where it is ready to return data on any of
	 * its accessor methods.
	 * @see com.ibm.ui.framework.DataBean
	 */
	public void load() {
	}

	/**
	 * Saves all changes that have been applied to this object via
	 * its accessor methods.  Called when the user task is committed.
	 * @see com.ibm.ui.framework.DataBean
	 */
	public void save() {
	}

}
